import Globe from '../src/index';
import React from 'react';
import ReactDOM from 'react-dom';
import createReactClass from 'create-react-class';

const Example = createReactClass({
  getInitialState() {
    return {
      center: [0, 0],
      diameter: 60,
    };
  },

  componentDidMount() {
    if (navigator.geolocation) {
      navigator.geolocation.getCurrentPosition(this.onGeolocation);
    }
  },

  onGeolocation(position) {
    this.recenter([position.coords.longitude, position.coords.latitude]);
  },

  recenter(center) {
    this.setState({center});
  },

  makeBigger() {
    this.setState(({diameter}) => ({diameter: Math.min(200, diameter + 10)}));
  },

  makeSmaller() {
    this.setState(({diameter}) => ({diameter: Math.max(40, diameter - 10)}));
  },

  render() {
    const {center, diameter} = this.state;
    const formattedCenter = center.map(value => value.toFixed(2)).join(', ');

    const markup = `<Globe center={[${formattedCenter}]} diameter={${diameter}} />`;

    return (
      <section>
        <h1>React Globe</h1>
        <Globe center={center} diameter={diameter} />
        <pre>
          <code>{markup}</code>
        </pre>
        <p>
          <a onClick={this.makeSmaller} id="make-smaller">
            ﹣
          </a>
          &nbsp;resize&nbsp;
          <a onClick={this.makeBigger} id="make-bigger">
            ﹢
          </a>
        </p>
        <ul>
          <li>
            <a onClick={() => this.recenter([151.2, -33.9])} id="syndey">
              Sydney, Australia
            </a>
          </li>
          <li>
            <a onClick={() => this.recenter([-74.0, 40.7])}>New York, USA</a>
          </li>
          <li>
            <a onClick={() => this.recenter([121.5, 31.2])}>Shanghai, China</a>
          </li>
          <li>
            <a onClick={() => this.recenter([3.4, 6.5])}>Lagos, Nigeria</a>
          </li>
          <li>
            <a onClick={() => this.recenter([0, -90])}>The South Pole</a>
          </li>
          <li>
            <a onClick={() => this.recenter([0, 90])}>The North Pole</a>
          </li>
        </ul>
      </section>
    );
  },
});

ReactDOM.render(<Example />, document.getElementById('example'));
